package com.sky.ioc.service.security.impl;

import com.sky.ioc.config.RestTemplateConfig;
import com.sky.ioc.entity.domain.security.SecurityDoorRecord;
import com.sky.ioc.mapper.security.SecurityDoorRecordMapper;
import com.sky.ioc.service.security.SecurityDoorRecordService;
import com.sky.ioc.tool.ReturnMsg;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.concurrent.ThreadLocalRandom;

@Service
@Slf4j
public class SecurityDoorRecordServiceImpl implements SecurityDoorRecordService {
    @Autowired
    RestTemplateConfig restTemplateConfig;

    @Autowired
    SecurityDoorRecordMapper securityDoorRecordMapper;

    final static  String SECURITY_DOOR_RECORD_URL="/api/safety/Hikvision/record/list";
    @Override
    public ReturnMsg getSecurityDoorRecordData() {
        String url = restTemplateConfig.addBaseUrl(SECURITY_DOOR_RECORD_URL)+"?pageNum=1&pageSize=1000";;
        RestTemplate restTemplate = restTemplateConfig.build();
        ResponseEntity<Map> responseEntity = restTemplate.getForEntity(url, Map.class);
        Map<String, Object> body = responseEntity.getBody();
        Integer code = (Integer)body.get("code");
        String message = (String)body.get("msg");
        if(code==200){
            ThreadLocalRandom random = ThreadLocalRandom.current();
            ArrayList list = (ArrayList) body.get("rows");
            if(list!=null&&list.size()>0){
                securityDoorRecordMapper.delete(null);
                for (int i=0;i<list.size();i++){
                    LinkedHashMap json = (LinkedHashMap) list.get(i);
                    SecurityDoorRecord securityDoorRecord = new SecurityDoorRecord();
                    securityDoorRecord.setId((Integer) json.get("id"));
                    if(json.get("employeeName")!=null){
                        securityDoorRecord.setName(String.valueOf(json.get("employeeName")));
                    }

                    securityDoorRecord.setTime(String.valueOf(json.get("eventTime")));
                    securityDoorRecord.setDoorId(Integer.parseInt(String.valueOf(json.get("doorId"))));
                    securityDoorRecord.setInOutType(String.valueOf(json.get("inAndOutType")));
                    securityDoorRecord.setType(String.valueOf(json.get("eventType")));
                    securityDoorRecordMapper.insert(securityDoorRecord);
                }
            }
            return ReturnMsg.ok();

        }else{
            log.info("获取门禁记录数据："+message);
            return  ReturnMsg.fail(message);
        }
    }
}
